#pragma hdrstop
#include <condefs.h>
#include <stdio.h>
#include <math.h>
#include <stdlib>
#include <ibase.h>
#include "../del_stat.h"


//---------------------------------------------------------------------------
USERES("del_stattest.res");
USEUNIT("..\del_stat.c");
//---------------------------------------------------------------------------
#pragma argsused

void failed(char* s){
  printf("test failed %s, program stoped",s);
  scanf("a");
  exit(EXIT_FAILURE);
}

bool test_nodata(){
  int h;
  double d;
  printf("test No Data");
  h=StatInit();
  d=StatMedian(&h);
  printf("Median:%g\n",d);
  if(fabs(d-0)>1e-8)failed("Median");
  d=StatMean(&h);
  printf("Mean:%g\n",d);
  if(fabs(d-0)>1e-8)failed("Mean");
  StatFree(&h);
  return 0;
}

bool test_smalldata(){
  int h,i;
  double d;
  printf("Median test (2,3,10)");
  h=StatInit();
  d=2; StatAdd(&h,&d);
  d=3; StatAdd(&h,&d);
  d=10;StatAdd(&h,&d);
  d=StatMedian(&h);
  printf(" result is:%g\n",d);
  if(fabs(d-3)>1e-8)failed("Median");
  d=StatMean(&h);
  printf("Mean result is:%g\n",d);
  if(fabs(d-5)>1e-8)failed("Mean");
  d=5; StatAdd(&h,&d);
  printf("Add value %g",d);
  d=StatMedian(&h);
  printf(" Median result is:%g\n",d);
  if(fabs(d-4)>1e-8)failed("Median Even Value");
  d=StatMean(&h);
  printf("Mean result is:%g\n",d);
  if(fabs(d-5)>1e-8)failed("Mean");
  d=StatMin(&h);
  printf("Min is:%g\n",d);
  if(fabs(d-2)>1e-8)failed("Min");
  d=StatRange(&h);
  printf("Range is:%g\n",d);
  if(fabs(d-8)>1e-8)failed("Range");
  d=StatSum(&h);
  printf("Sum is:%g\n",d);
  if(fabs(d-20)>1e-8)failed("Sum");
  d=StatStdDev(&h);
  printf("StdDev is:%g\n",d);
  if(fabs(d-3.082207001)>1e-8)failed("StdDev");
  d=StatStdDevSel(&h);
  printf("StdDevSel is:%g\n",d);
  if(fabs(d-3.559026084)>1e-8)failed("StdDevSel");
  d=StatSkew(&h);
  printf("Skew is:%g\n",d);
  if(fabs(d-0.768417)>1e-6)failed("Skew");
  d=StatSkewSel(&h);
  printf("SkewSel is:%g\n",d);
  if(fabs(d-1.330937732)>1e-8)failed("SkewSel");
  d=StatVariance(&h);
  printf("Variance is:%g\n",d);
  if(fabs(d-9.5)>1e-8)failed("Variance");
  d=StatVarianceSel(&h);
  printf("Variance Sel is:%g\n",d);
  if(fabs(d-12.666666666667)>1e-8)failed("Variance Sel");
  i=0;
  d=StatCommonMoment(&h,&i);
  printf("Common moment(0): %g\n",d);
  if(fabs(d-1)>1e-8)failed("Common moment(0)");
  i=1;
  d=StatCommonMoment(&h,&i);
  printf("Common moment(1): %g\n",d);
  if(fabs(d-5)>1e-8)failed("Common moment(1)");
  StatFree(&h);
  return 0;
}

bool test_clear(){
  int i,h;
  double d;
  printf("Add 20 items");
  h=StatInit();
  d=5.0;
  for(i=0;i<20;i++)StatAdd(&h,&d);
  d=StatMean(&h);
  printf("Mean result is:%g\n",d);
  if(fabs(d-5)>1e-8)failed("Mean");
  if(StatCount(&h)!=20)failed("Count");
  StatClear(&h);
  d=12.0;
  for(i=0;i<40;i++)StatAdd(&h,&d);
  d=StatMean(&h);
  printf("Mean result is:%g\n",d);
  if(fabs(d-12)>1e-8)failed("Mean");
  if(StatCount(&h)!=40)failed("Count");
  StatFree(&h);
  return 0;
}

bool test_timestamp(){
  int h;
  double d;
  ISC_TIMESTAMP *tm;
  printf("Time Stamp");
  h=StatInit();
  tm=(ISC_TIMESTAMP*)malloc(sizeof(ISC_TIMESTAMP));
  tm->timestamp_date=10;
  tm->timestamp_time=3600*24*0.5*10000;
  StatAddTimeStamp(&h,tm);
  d=StatMean(&h);
  printf("time result is:%g\n",d);
  if(fabs(d-10.5)>1e-8)failed("time");
  tm=StatMeanTimeStamp(&h);
  if(tm->timestamp_date!=10)failed("date");
  if(tm->timestamp_time!=3600*24*0.5*10000)failed("time");
  StatClear(&h);
  d=-10.25;
  StatAdd(&h,&d);
  tm=StatMeanTimeStamp(&h);
  if(tm->timestamp_date!=-11)failed("date");
  if(tm->timestamp_time!=3600*24*0.75*10000)failed("time");
  StatFree(&h);
  return 0;
}

bool test_dup(){
  int i,h,h2;
  double d;
  h=StatInit();
  d=5.0;
  for(i=0;i<20;i++)StatAdd(&h,&d);
  h2=StatDuplicate(&h);
  d=-33;
  StatAdd(&h2,&d);
  d=StatMean(&h);
  if(fabs(d-5.0)>1e-8)failed("Test Dup failed");
  d=StatMean(&h2);
  if(fabs(d-(5.0*20-33)/21.0)>1e-8)failed("Test Dup copy failed");
  StatFree(&h);
  StatFree(&h2);
  return 0;
}

bool test_getitem(){
  int i,h;
  double d;
  h=StatInit();
  d=5.0;
  for(i=0;i<20;i++)StatAdd(&h,&d);
  d=-33;
  StatAdd(&h,&d);
  i=20;
  d=StatGetItem(&h,&i);
  if(fabs(d+33)>1e-8)failed("Get Item");
  i=0;
  d=StatGetItem(&h,&i);
  if(fabs(d-5)>1e-8)failed("Get Item");
  StatFree(&h);
  return 0;
}

bool test_RMS(){
  int i,hx,hy,hr;
  double d,d2;
  hx=StatInit(); hy=StatInit();
  d=2.0;
  StatAdd(&hx,&d);
  d=5.0;
  StatAdd(&hy,&d);
  i=0;
  hr=StatRMS(&hx,&hy,&i);
  d=StatGetItem(&hr,&i);
  printf("RMS:%g\n",d);
  if(fabs(d-5)>1e-8)failed("RMS p0");
  StatFree(&hr);
  d=2.0;
  StatAdd(&hx,&d);
  d=7.0;
  StatAdd(&hy,&d);
  hr=StatRMS(&hx,&hy,&i);
  d=StatGetItem(&hr,&i);
  printf("RMS:%g\n",d);
  if(fabs(d-6)>1e-8)failed("RMS p0");
  StatFree(&hr);
  d=3.0;
  StatAdd(&hx,&d);
  d=8.0;
  StatAdd(&hy,&d);
  hr=StatRMS(&hx,&hy,&i);
  d=StatGetItem(&hr,&i);
  printf("RMS:%g\n",d);
  if(fabs(d-(20.0/3.0))>1e-8)failed("RMS p0");
  StatFree(&hr);
  i=1;
  hr=StatRMS(&hx,&hy,&i);
  i=0; d=StatGetItem(&hr,&i);
  i=1; d2=StatGetItem(&hr,&i);
  printf("RMS:%g + x* %g\n",d,d2);
  if(fabs(d-2)>1e-8)failed("RMS p1");
  if(fabs(d2-2)>1e-8)failed("RMS p1");
  StatFree(&hr);
  d=3.0;
  StatAdd(&hx,&d);
  d=10.0;
  StatAdd(&hy,&d);
  i=1;
  hr=StatRMS(&hx,&hy,&i);
  i=0; d=StatGetItem(&hr,&i);
  i=1; d2=StatGetItem(&hr,&i);
  printf("RMS:%g + x * %g\n",d,d2);
  if(fabs(d-0)>1e-8)failed("RMS p1");
  if(fabs(d2-3)>1e-8)failed("RMS p1");
  StatFree(&hx); StatFree(&hy);
  return 0;
}

bool test_poly(){
  int h;
  double d;
  h=StatInit();
  d=5.0;
  StatAdd(&h,&d);
  d=2.0;
  StatAdd(&h,&d);
  d=0;
  d=StatPoly(&h,&d);
  printf("Poly:%g\n",d);
  if(fabs(d-5)>1e-8)failed("poly");
  d=5;
  d=StatPoly(&h,&d);   // 5 + 2*5 = 15
  printf("Poly:%g\n",d);
  if(fabs(d-15)>1e-8)failed("poly");
  StatFree(&h);
  return 0;
}

int main(int argc, char **argv)
{
  printf("del_stat.c test application\n");
  test_nodata();
  test_smalldata();
  test_clear();
  test_timestamp();
  test_dup();
  test_getitem();
  test_RMS();
  test_poly();
  scanf("a");
  return 0;
}

