/*
	del_stat.h - header file for del_stat.c

	Copyright (C) 2002  Slavomir Skopalik

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Library General Public
	License as published by the Free Software Foundation; either
	version 2 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Library General Public License for more details.

	You should have received a copy of the GNU Library General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

e-mail:skopalik@hlubocky.del.cz
http://hlubocky.del.cz/udf

*/
#ifndef __DEL_STAT_H
 #define __DEL_STAT_H
 #include "ibase.h"
 #ifdef _WIN32
   #ifdef DEL_STAT_C
	#define _fun_mod dllexport
   #else
	#define _fun_mod dllimport
   #endif
   #define EXPORT(type, fndef) __declspec(_fun_mod) type __cdecl fndef
 #else
   #define EXPORT(type, fndef) type fndef
   #define USERES(a)
 #endif
 typedef double *pdouble;
 typedef int *pint;
 #ifdef __cplusplus
  extern "C" {
 #endif
	EXPORT(int, StatInit());
	EXPORT(int, StatInitEx(pint count));
	EXPORT(int, StatFree(pint handle));
	EXPORT(int, StatAdd(pint handle,pdouble value));
	EXPORT(int, StatAddTimeStamp(pint handle, ISC_TIMESTAMP *tm));
	EXPORT(double, StatGetItem(pint handle, pint index));
        EXPORT(ISC_TIMESTAMP*, StatGetItemTimeStamp(pint handle, pint index));
	EXPORT(int, StatCount(pint handle));
	EXPORT(int, StatClear(pint handle));
	EXPORT(int, StatDuplicate(pint handle));
	EXPORT(int, StatLS(pint XValues, pint YValues, pint degree));
        EXPORT(int, StatPoly(pint handle,pdouble X));
	EXPORT(int,StatSort(pint handle));
	EXPORT(double,StatMedian(pint handle));
	EXPORT(ISC_TIMESTAMP* ,StatMedianTimeStamp(pint handle));
	EXPORT(double,StatMean(pint handle));
	EXPORT(ISC_TIMESTAMP* ,StatMeanTimeStamp(pint handle));
	EXPORT(double,StatSum(pint handle));
	EXPORT(double,StatMin(pint handle));
	EXPORT(double,StatMax(pint handle));
	EXPORT(double,StatRange(pint handle));
	EXPORT(double,StatVariance(pint handle));
	EXPORT(double,StatStdDev(pint handle));
	EXPORT(double,StatVarianceSel(pint handle));
	EXPORT(double,StatStdDevSel(pint handle));
	EXPORT(double,StatCentralMoment(pint handle,pint moment));
	EXPORT(double,StatCommonMoment(pint handle,pint moment));
	EXPORT(double,StatSkew(pint handle));
	EXPORT(double,StatSkewSel(pint handle));
 #ifdef __cplusplus
  }
 #endif
#endif
